/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WFREESTREAMRESIDUAL_H
#define WFREESTREAMRESIDUAL_H

#include "dart.h"

#include <vector>
#include <Eigen/Dense>

namespace dart
{

/**
 * @brief Formulation of freestream boundary residuals
 */
class DART_API FreestreamResidual
{
public:
    // Newton
    static Eigen::VectorXd build(tbox::Element const &e, std::vector<double> const &phi, Freestream const &fs);
    // Adjoint
    static Eigen::VectorXd buildGradientAoa(tbox::Element const &e, std::vector<double> const &phi, Freestream const &fs);
};

} // namespace dart
#endif // WFREESTREAMRESIDUAL_H
